/*
 * $Id: XMLHandler.java,v 1.1.1.1 2002/08/14 12:43:10 kenta Exp $
 *
 * Copyright 2002 Kenta Cho. All rights reserved.
 */
package abagames.thiy;

import java.io.*;

/**
 * Read XML file and extract an element.
 *
 * @version $Revision: 1.1.1.1 $
 */
public class XMLHandler {

  public static String readFileString(String fileName)
   throws FileNotFoundException, UnsupportedEncodingException, IOException {
    StringBuffer strBuf = new StringBuffer();
    BufferedReader reader =
     new BufferedReader(new InputStreamReader(new FileInputStream(fileName), "UTF-8"));
    for ( ; ; ) {
      String ln = reader.readLine();
      if ( ln == null ) break;
      strBuf.append(ln);
    }
    reader.close();
    return strBuf.toString();
  }

  public static void writeFileString(String fileName, String str)
   throws FileNotFoundException, UnsupportedEncodingException {
    PrintWriter writer =
      new PrintWriter(new OutputStreamWriter(new FileOutputStream(fileName), "UTF-8"));
    writer.print(str);
    writer.close();
  }

  public static String getElement(String xmlStr, String tag) {
    int stIdx = xmlStr.indexOf("<"+tag);
    if ( stIdx == -1 ) return "";
    stIdx = xmlStr.indexOf('>', stIdx) + 1;
    int edIdx = xmlStr.indexOf("</"+tag, stIdx);
    return xmlStr.substring(stIdx, edIdx);
  }

  public static String getElement(String xmlStr, String tag, String atr) {
    int stIdx = xmlStr.indexOf("<"+tag+" "+atr);
    if ( stIdx == -1 ) return "";
    stIdx = xmlStr.indexOf('>', stIdx) + 1;
    int edIdx = xmlStr.indexOf("</"+tag, stIdx);
    return xmlStr.substring(stIdx, edIdx);
  }

  public static String getElementWithTag(String xmlStr, String tag) {
    int stIdx = xmlStr.indexOf("<"+tag);
    if ( stIdx == -1 ) return "";
    int edIdx = xmlStr.indexOf("</"+tag, stIdx);
    edIdx = xmlStr.indexOf('>', edIdx) + 1;
    return xmlStr.substring(stIdx, edIdx);
  }

  public static String removeElement(String xmlStr, String tag) {
    /*int stIdx = xmlStr.indexOf("<"+tag);
    if ( stIdx == -1 ) return "";
    int edIdx = xmlStr.indexOf("</"+tag, stIdx);
    edIdx = xmlStr.indexOf('>', edIdx) + 1;
    return xmlStr.substring(edIdx);*/
    int stIdx = xmlStr.indexOf("<"+tag);
    if ( stIdx == -1 ) return xmlStr;
    int edIdx = xmlStr.indexOf("</"+tag, stIdx);
    edIdx = xmlStr.indexOf('>', edIdx) + 1;
    return xmlStr.substring(0, stIdx) + removeElement(xmlStr.substring(edIdx), tag);
  }

  public static String replaceElement(String xmlStr, String tag, String html) {
    int stIdx = xmlStr.indexOf("<"+tag);
    if ( stIdx == -1 ) return xmlStr;
    int edIdx = xmlStr.indexOf("/>", stIdx) + 2;
    return xmlStr.substring(0, stIdx) + html + replaceElement(xmlStr.substring(edIdx), tag, html);
  }
}
